;
;Fido Bugger IO DEF Include file.
;
;30 July 85
;
;------ Hardware Interrupts --------
;
;These are the interrupts jumpered on the
;SBC 86/12 board. Not all are actually used.
;
pic0int	equ	40h		;8259A vector,
keyint	equ	pic0int+0	;keyboard int,
clk0int	equ	pic0int+1	;Timer #0,
clk1int	equ	pic0int+2	;Timer #1,
a534int	equ	pic0int+3	;534 board int,
tbeint	equ	pic0int+4	;console TBE,
ext0int	equ	pic0int+5	;Buss INTR0/,
ext6int	equ	pic0int+6	;Buss INTR6/,
tmoint	equ	pic0int+7	;Buss timeout,

pic1int	equ	48h		;reserved 8259A
;
;------- Software Interrupts --------
;
tick	equ	50h		;G.P. Interrupt
serint	equ	55h		;serial int.
serin0	equ	56h		;534 Port #0 in
serin1	equ	57h		;534 Port #1 in
serin2	equ	58h		;534 Port #2 in
serin3	equ	59h		;534 Port #3 in
;
;MSDOS 2.00 Fast Console Interrupt
;
conint	equ	29h		;fast console,
;
;-------- Misc. ---------
;
;MBI Inc. Perfect slave. Resides at the 512K
;boundary.
;
slave	equ	28h
slaveseg equ	8000h
;
;86/12 onboard devices.
;
pici1	equ	0c0h	;(read IR or IS)
pici2	equ	0c2h	;(read mask)
pici3	equ	0c2h
pici4	equ	0c2h
pico1	equ	0c2h
pico2	equ	0c0h
pico3	equ	0c0h
;
;PIC mode bytes.
;
icw1 equ 00011011b ;level trig, single, ICW4
icw2 equ pic0int    ;vectors 40-47,
icw4 equ 00001111b ;buf. master, AEOI, 8086
;
;	 +-------- buss int
;	 |+------- INTR6
;	 ||+------ INTR0
;	 |||+----- TBE
;	 ||||+---- 534
;	 |||||+--- timer 1
;        ||||||+-- timer 0
;        |||||||+- RDA
;        ||||||||
ocw1 equ 11110010b
tbemsk equ 00010000b ;console TBE mask,
ocw2 equ 11000010b ;IR3 is highest, (534 board)
ocw3 equ 00001010b ;read IR register,

pcimode	equ	0dah
pcidata	equ	0d8h

pitmode	equ	0d6h	;mode port,
pittmr0	equ	0d0h	;timer count ports,
pittmr1	equ	0d2h
pittmr2	equ	0d4h
;
;........................................
;Main 8253 modes and counts. The mode
;used is critical: see FIDO.DOC
;timer 0 is 1.23 mHz,
;timer 1 is 153 kHz.
;
pitm0 	equ 	00110000b ;mode 0, ctr 0
pitm1	equ	01110000b ;mode 0, ctr 1
tm0cnt	equ	12288	  ;ctr 0 count, 10 mS,
tm1cnt	equ	1536	  ;ctr 1 count, 10 mS,
;
;Predefined time constants.
;
ONESEC	equ 100		;100 10mS ticks,
;........................................
;
;SBC 86/12 PPI (8255)
;
ppictl	equ	0ceh
ppia	equ	0c8h
ppib	equ	0cah
ppic	equ	0cch
;
;	534 I/O board
;
icw1a equ 00011011b;level, single, ICW4,
icw2a equ pic1int  ;not used,
icw4a equ 00000011b;non-buf, 8086, AEOI
ocw1a equ 00000000b;all enabled,
ocw2a equ 01000000b;no operation
ocw3a equ 00001010b ;read IR register,
;ocw3a equ 01001011b;reset sp msk, read IS,

icw1b equ icw1a	   ;same as above,
icw2b equ icw2a
icw4b equ icw4a
ocw1b equ 11111111b;all disabled,
ocw2b equ ocw2a
ocw3b equ ocw3a
;
;Comark 534 I/O device definitions.
;
abase	equ	10h
adataa	equ	abase		;8251 data,
astata	equ	abase+1		;8251 status,
adatab	equ	abase+2
astatb	equ	abase+3
adatac	equ	abase+4
astatc	equ	abase+5
adatad	equ	abase+6
astatd	equ	abase+7

aicw1a	equ	abase+8		;8259A ICW1,
aocw2a	equ	abase+8
aocw3a	equ	abase+8

aocw1a	equ	abase+9
aicw2a	equ	abase+9
aicw3a	equ	abase+9
aicw4a	equ	abase+9

aicw1b	equ	abase+10	;8259A
aocw2b	equ	abase+10
aocw3b	equ	abase+10

aocw1b	equ	abase+11
aicw2b	equ	abase+11
aicw3b	equ	abase+11
aicw4b	equ	abase+11

apit0a	equ	abase		;1st 8253
apit1a	equ	abase+1
apit2a	equ	abase+2
apitca	equ	abase+3

apit0b	equ	abase+4
apit1b	equ	abase+5
apit2b	equ	abase+6
apitcb	equ	abase+7

acblock	equ	abase+12	;select control
adblock	equ	abase+13	;select data
atest	equ	abase+14	;test mode sel
areset	equ	abase+15	;reset board
;
;Masks for the 8259 on the 534 board.
;
rda0m	equ	00000001b
tbe0m	equ	00000010b
rda1m	equ	00000100b
tbe1m	equ	00001000b
rda2m	equ	00010000b
tbe2m	equ	00100000b
rda3m	equ	01000000b
tbe3m	equ	10000000b
;
;DTC-86 / Xebec Controller and interface
;
csr	equ	0a0h	;base, cmd/status reg,
ccr	equ	csr+1	;command completion,
dal	equ	csr+2	;data addr low,
dah	equ	csr+3	;data addr high,
cal	equ	csr+4	;cmd addr low,
cah	equ	csr+5	;cmd addr high,
dat	equ	csr+6	;data addr top,
cat	equ	csr+7	;cmd addr top,

xread	equ	8	;read command,
xwrite	equ	10	;write command,
xstat	equ	3	;status command,
xcheck	equ	0	;check ready,
;
;Intel iSBC 208 Diskette Controller Driver
;
;HUT, SRT, HLT and ND for the specify
;command.
;
srthut	equ	11001111b ;SRT=4Ms, HUT=240Ms,
hltnd	equ	00011010b ;HLT=26Ms, ND =DMA,
;
;Floppy commands.
;
readc	equ	6
writec	equ	5
statc	equ	4
seekc	equ	15	;seek a track,
recalc	equ	7	;recal drive,
skstc	equ	8
specc	equ	3	;specify
readidc	equ	10	;read ID
drvstc	equ	4	;sense drive status
;
;Intel SBC-208 IO Ports
;
basep	equ	40h

fdcstat	equ basep + 10h	;status port,
fdcdata	equ basep + 11h	;data port,

ch0ap	equ basep + 00h	;ch. 0 addr port,
ch0cp	equ basep + 01h	;ch. 2 count port,
dcmdp 	equ basep + 08h	;DMA command
maskp 	equ basep + 0ah	;DMA mask port,
modp	equ basep + 0bh	;DMA mode port
dflp	equ basep + 0ch	;DMA first/last
drcp	equ basep + 12h	;drive aux port
resp	equ basep + 13h	;board reset
seglp	equ basep + 14h	;segment low
seghp	equ basep + 15h	;segment hi
;
;Bits for the DMA Mode Port
;
dmawb	equ	44h	;DMA write/disk read
dmarb	equ	48h	;DMA read/disk write
;
;Channel 0 enable bits for Mask Port
;
dmacb	equ	0
;
;Bits for the aux port
;
MTR	equ	02h	;motor on
RDY	equ	04h	;force ready
MINI	equ	08h	;mini clock
