#
# Make file for Grafix, Microsoft C. Typing 'make makemsc' will build
#   a small model library called grafix.lib. To compile a different
#   memory model, set other compiler options, or change the name of
#   the library, set the cflags, asmflags, and/or libname macros
#   from the command line. For example, if you want to build a
#   medium model library, you should type:
#      make cflags=/AM asmflags=/DMEDIUM libname=grafixm makemsc
#   Be sure that no object modules that were compiled with a different
#   memory model are lying around! The batch file buildmsc.bat will
#   automatically build all four libraries from scratch. Oh, and also
#   be sure you have the compiler properly configured so that it
#   can find its include files. You will also need to have MASM and
#   Microsoft's LIB utility on your search path.
#

cflags=
asmflags=
libname=grafix

# /Gs = no stack probes
.c.obj:
  msc/Gs $(cflags) $*;
  lib $(libname) -+$*;

# /Mx = case is signifigant
.asm.obj:
  masm/Mx $(asmflags) $*;
  lib $(libname) -+$*;

cgagraf.obj: cgagraf.c macros.h grafsys.h cga.h

cgagrafa.obj: cgagrafa.asm macros.ah

egagraf.obj: egagraf.c macros.h grafsys.h ega.h

egagrafa.obj: egagrafa.asm macros.ah

graf.obj: graf.c macros.h graf.h grafsys.h cga.h ega.h

graflib.obj: graflib.asm macros.ah

halofake.obj: halofake.c macros.h graf.h

