#
# Make file for Grafix, Turbo C. Typing 'make -fmaketc' will build
#   a small model library called grafix.lib. To compile a different
#   memory model, set other compiler options, or change the name of
#   the library, set the cflags, asmflags, and/or libname macros
#   from the command line. For example, if you want to build a
#   medium model library, you should type:
#      make -Dcflags=-mm -Dasmflags=/DMEDIUM -Dlibname=grafixm -fmaketc
#   Be sure that no object modules that were compiled with a different
#   memory model are lying around! The batch file buildtc.bat will
#   automatically build all four libraries from scratch. Oh, and also
#   be sure you have the compiler properly configured so that it
#   can find its include files. You will also need to have MASM and
#   Microsoft's LIB utility on your search path.
#

#
# Note: on the version of Turbo Make I have (dated 1:00 may 13), the $d
#  macro doesn't seem to work. Thus, you'll always have to specify cflags,
#  asmflags, and libname from the command line (buildtc.bat does this, so
#  it's all right). If the make you have works in this regard, remove
#  the #'s from the following lines.
#

#!if $d(cflags)
#cflags=
#!endif
#!if !$d(asmflags)
#asmflags=/DSMALL
#!endif
#!if !$d(libname)
#libname=grafix
#!endif

# -c = don't link
.c.obj:
  tcc -c $(cflags) $*
  lib $(libname) -+$*;

# /Mx = case is signifigant
.asm.obj:
  masm /Mx $(asmflags) $*;
  lib $(libname) -+$*;

$(libname).lib: graf.obj graflib.obj cgagrafa.obj egagrafa.obj cgagraf.obj \
                egagraf.obj halofake.obj

graf.obj: graf.c macros.h graf.h grafsys.h cga.h ega.h

graflib.obj: graflib.asm macros.ah

cgagrafa.obj: cgagrafa.asm macros.ah

egagrafa.obj: egagrafa.asm macros.ah

cgagraf.obj: cgagraf.c macros.h grafsys.h cga.h

egagraf.obj: egagraf.c macros.h grafsys.h ega.h

halofake.obj: halofake.c macros.h graf.h

