page 59,96
title PALS.ASM Version 2.1
comment |


|
.sall
.radix 16
write   macro   row, column, text, attribute
        push bx         ;preserve base ptr, extra segment
        push es
        push ds
        pop es          ;needed for scan
        mov al,'$'      ;end of string character
        mov di,offset ds:text     ;points to the beginning
        mov cx,80d      ;maximum string length
        cld             ;forward direction
        repne scasb     ;look for '$'
        sub cx,80d
        neg cx          ;string length including '$'
        dec cx          ;string length
        mov     bp,offset ds:text
        mov     ax,1301 ;Write string, move cursor
        mov     bh,0    ;Page#
        mov     bl,attribute
        mov     dh,row
        mov     dl,column
        int     10h
        pop es          ;restore extra segment, base register
        pop bx
        endm
        page
PGROUP  group   STACK,CODE,DATA

STACK   segment byte stack 'prog'
STACK   ends

DATA    segment byte public 'data'
        assume ds:PGROUP
inc_flag db 0
default_palette db 0,1,2,3,4,5,14,7,38,39,3a,3bh,3c,3dh,3e,3f,0
id_locs dw 501,50bh,515,51f,529,533,53dh,547
        dw 0c01,0c0bh,0c15,0c1f,0c29,0c33,0c3dh,0c47
header  db 'Set Values for Individual EGA Palettes.$'
myname  db 'Written by L. Nemec. Uses NEWFONT.COM Version 3.0,'
        db ' 9-7-86.$'
id_expl db 'Palette color shown in hex (00rg bRGB) and octal '
        db '(rgb RGB).$'
instr1  db 'Press palette number (0 - F) to increment or de'
        db 'crement palette color.$'
instr2  db 'Increment mode () is the default. Press  to '
        db ' invoke decrement mode.$'
instr3  db 'R (r) resets default palette values.$'
instr4  db 'Save palette configuration on executable'
        db ' file mypal.com by pressing S (s).$'
instr5  db 'Exit program by pressing Esc.$'
pal_id1 db '   0         1         2         3         4'
        db '         5         6         7$'
pal_id2 db '   8         9         A         B         C'
        db '         D         E         F$'

fnam    db 'mypal.com',0
bad_file db 'File error, mypal.com not created.$'
file_ok db 'File mypal.com created.$'

DATA    ends
        page
CODE    segment byte public 'prog'
        assume cs:PGROUP,ds:PGROUP,es:PGROUP
        org 100
begin:  call start
        mov ah,4c
        xor al,al       ;zero return code
        int 21          ;exit
error:
        mov ah,02
        xor bh,bh
        mov dx,1700     ;line 24
        int 10          ;move cursor there
        mov ah,9
        mov dx,offset no_newfnt
        int 21
        mov ah,4c
        mov al,0ff      ;return code 255
        int 21

start:
        call draw_boxes
        mov ax,0cc00    ;newfnt int 10 extension
        int 10
        cmp cx,0abcdh   ;newfont loaded?
        jne error       ;no, it is not
        mov es,bx       ;segment of palette array
        mov bx,0f0      ;offset of the array
        call display_id
        write 0,17d,header,4
        write 1,10d,myname,5
        write 2,0,pal_id1,15d
        write 9,0,pal_id2,15d
        write 16d,0,id_expl,6
        write 18d,0,instr1,2
        write 19d,0,instr2,2
        write 20d,0,instr3,2
        write 21d,0,instr4,2
wr_i5:  write 24d,20d,instr5,2
keychk: mov     ah,0bh  ;check input status
        int     21h
        cmp     al,0ffh ;Any key hit??
        je      chk_key
        jmp keychk      ;keep trying
chk_key:
        mov     ah,07h  ;character found so
        int     21h
        cmp     al,27d  ;Check char for ESC
        jne     cont
        mov ax,3
        int 10          ;clear screen
        ret             ;exit
cont:
        cmp     al,0
        jnz     check_number
        mov ah,7        ;another call for this code
        int 21          ;extended ASCII
        cmp     al,72d  ;cursor up?
        jnz     curs_down
        mov     inc_flag,0
        jmp     keychk
curs_down:
        cmp al,80d
        jnz keychk
        mov     inc_flag,1
        jmp keychk
check_number:
        cmp     al,30   ;check for hex digit
        jc keychk       ;too low
        cmp     al,3a
        jc      digit_ok ;0 - 9
        and     al,0df  ;make uppercase
        cmp     al,'G'
        jnc check_R     ;reset code?
        sub al,7        ;maybe digit
        cmp al,3a
        jnc digit_ok    ;A - F
        jmp keychk      ;below 'A'
check_R:
        cmp al,'R'
        jnz check_S     ;look for save command
        mov di,0f0      ;palette array destination
        mov si,offset ds:default_palette
        mov cx,11       ;17 values
        rep movsb       ;replace palette array
        call display_id
        jmp set_pal
check_S:
        cmp al,'S'
        jnz keychk      ;invalid command
        jmp stor_f
digit_ok:
        sub al,30       ;turn ASCII to binary
        xor ah,ah
        mov si,ax
        cmp inc_flag,0
        jz incr_pal
        dec byte ptr es:[bx+si]
        jmp set_pal
incr_pal:
        inc byte ptr es:[bx+si] ;increment palette
set_pal:
        and byte ptr es:[bx+si],3f ;modulo 64 decimal
        mov ax,1002     ;set palettes code
        mov dx,0f0      ;palette array offset
        int 10          ;reset it
        mov di,si
        add di,di       ;word array of cursor positions
        call write_color_no
        jmp keychk      ;keep going
stor_f:
        push bx         ;preserve base register
        mov si,0f0      ;palette array is the source
        mov di,offset palette       ;to be stored
        push es         ;preserve es,ds
        push ds
        push es
        pop ds
        push cs
        pop es          ;es is now down there
        mov cx,11
        rep movsb       ;copy resident array for storage
        pop ds          ;restore data segment
        pop es          ;restore extra segment
        mov dx,offset ds:fnam
        mov ah,3c               ;create file code
        xor cx,cx               ;no special attribute
        int 21
        jc file_err             ;error occured
        mov bx,ax               ;file handle
        mov dx,offset file_code
        mov cx,100              ;256 bytes
        mov ah,40
        int 21
        jc file_err
        mov ah,3e               ;close file code
        int 21
        jc file_err
        write 22d,22d,file_ok,4
        pop bx                  ;restore base register
        jmp wr_i5
file_err:
        write 22d,20d,bad_file,84

        page

draw_boxes proc
        mov ax,3
        int 10          ;initialize display in text
        mov dx,300      ;cursor 3,0
        xor si,si       ;attribute 0
        call eight_boxes
        mov dx,501      ;cursor 5,1
        call id_space   ;upper box row id's
        mov dx,0a00     ;cursor 10,0
        mov si,8        ;attribute 8
        call eight_boxes
        mov dx,0c01     ;cursor 12,1
        call id_space   ;lower box row id's
        ret

eight_boxes proc
        mov cx,5        ;five rows of boxes
curr_attr:
        mov bx,si       ;current attribute
        push cx         ;preserve column count
        mov cx,8
        call box
        pop cx
        xor dl,dl       ;column 0
        inc dh          ;next row
        loop curr_attr
        ret

box     proc
        push cx         ;preserve column count
        mov ah,2        ;set cursor code
        int 10
        add dx,8        ;ready for little boxes
        mov ax,9dbh     ;alpha box character
        mov cx,8        ;eight of them
        int 10          ;write them with bl attr
        inc bl          ;next attribute
        mov ah,2
        int 10
        add dx,2        ;next color column
        mov ax,920      ;blanks
        push bx
        xor bl,bl       ;attribute 0
        mov cx,2        ;2 blanks
        int 10
        pop bx          ;restore attribute
        pop cx          ;restore column count
        loop box
        ret
box             endp
eight_boxes     endp

        page
id_space        proc
        mov cx,8        ;eight id's
        xor bl,bl       ;attribute 0
write_blanks:
        mov ah,2
        int 10          ;move cursor
        push cx         ;preserve loop count
        mov cx,6        ;6
        mov ax,920      ;spaces
        int 10          ;write them
        add dx,0a       ;next box
        pop cx          ;restore loop count
        loop write_blanks
        ret
id_space        endp
draw_boxes      endp

display_id      proc
        mov cx,10       ;16 palettes
        xor si,si       ;start at palette 0
        xor di,di
id_loop:
        push cx
        call write_color_no
        inc si
        inc di
        inc di
        pop cx
        loop id_loop
        ret
write_color_no  proc
        push bx
        mov al,es:[bx+si]       ;color no for pallete [si]
        mov bx,si               ;also the attribute
        mov bh,al               ;preserve color no, bl is attr
        cmp bl,0                ;pallete 0 (background)?
        jne proceed             ;no,keep the attribute
        mov bl,0f               ;palette F attribute instead
proceed:
        call hex_display
        mov al,bh               ;restore color no
        call oct_display
        pop bx
        ret
hex_display     proc
        mov dx,id_locs[di]       ;cursor position
        mov ah,2
        push bx
        xor bh,bh
        push ax                 ;ax not preserved on IBM EGA
        int 10                  ;move cursor
        pop ax
        pop bx
        mov cl,4
        shr al,cl               ;high nibble
        call make_hex
        call display
        inc dx
        mov ah,2
        push bx
        xor bh,bh
        int 10                  ;next character
        pop bx
        mov al,bh
        and al,0f               ;low nibble
        call make_hex
        call display
        ret

make_hex        proc
        cmp al,0a
        jnc A_F
        add al,30               ;ASCII 0-9
        ret
A_F:    add al,37
        ret
make_hex        endp
hex_display endp

oct_display     proc
        mov dx,id_locs[di]
        add dx,4
        mov ah,2
        push bx
        xor bh,bh
        push ax
        int 10
        pop ax
        pop bx
        mov cl,3
        shr al,cl               ;upper 3 bits
        add al,30               ;ASCII 0-7
        call display
        inc dx
        mov ah,2
        push bx
        xor bh,bh
        int 10
        pop bx
        mov al,bh
        and al,7                ;lower 3 bits
        add al,30
        call display
        ret
oct_display     endp


display         proc
        mov cx,1                ;one character
        mov ah,9
        push bx
        xor bh,bh
        int 10                  ;write char in AL, attr BL
        pop bx
        ret
display endp
write_color_no  endp
display_id     endp

        page
file_code:
        jmp orig
palette db 11 dup (0)
no_newfnt db 0dh,0a,'Load NEWFONT.COM Version 3.0 before '
        db 'running this program.$',0dh,0a
orig:
        mov ax,0cc00            ;newfont int 10 extension
        int 10
        cmp cx,0abcdh           ;newfont loaded?
        jnz fc_error
        mov es,bx               ;palette array segment
        mov si,103
        mov di,0f0              ;resident palette array
        mov cx,11
        rep movsb               ;replace by values stored here
        mov dx,0f0              ;offset of resident palettes
        mov ax,1002
        int 10                  ;palette reset
        mov ah,4c
        mov al,0                ;return code 0
        int 20                  ;exit
fc_error:
        mov ah,9
        mov dx,114
        int 21
        mov ah,4c
        mov al,0ff              ;return code 255
        int 21
CODE            ends
                end begin
