/*
    VISUAL.C   Visual Shell - MS DOS - Write by F. Bernardotti

	1986 Alessandria

	Compilare con Microsoft C 3.00 o 4.00

	             msc visual.c

				 link visual.obj /STACK:20000

	La VSH utilizza per le funzioni di posizionamento cursore,  per
	i colori dei caratteri e per altri scopi delle sequenze di ESC.
	Necessita del file ANSI.SYS inserito nel CONFIG.SYS

	La Visual Shell si interpone tra user e DOS al fine di eseguire
	controlli sulla natura dei files senza la necessita' di utiliz-
	zare i comandi di quest'ultimo.
	Le funzioni sono svolte mediante i tasti abbinati ai files    o
	alle directory visualizzate a gruppi di 20.
	Mi scuso per la cattiva formattazione del testo   ma  sotto  VI
	(editor di unix) tutto appariva regolare.
	Solo un ulteriore controllo con il type del DOS mi ha portato a
	rilevare le imperfezioni di allineamento delle righe.
	In ogni caso dal punto di vista funzionale questo non  presenta
	inconvenienti.
	Ad ogni files o directory sono abbinate le lettere minuscole da
	'a' fino a 't'.
	Premendo la lettera corrispondente  minuscola si ottengono  in-
	formazioni relative al file, quali tipo e byte.
	Premendo la lettera maiuscola (con SHIFT) si eseguono     varie
	funzioni relative alla natura del file stesso.
	Se il file e' eseguibile questo viene lanciato.
	Uscendo normalmente mediante opzioni si ritorna automaticamente
	alla VSH.
	Se il file corrisponde a una directory ci si entra dentro  e  i
	files, mostrati ordinati, diventano quelli della nuova dir.
	Se il file invece e' di testo viene editato.
	Altre funzioni corrispondenti ai tasti # e @ sono svolte da VSH
	e sono rispettivamente:
	#  riporta informazioni sul disco quali spazio totale e libero
	@  riporta informazioni sui devices collegati
	!  stampa la schermata
	Consegno di questa i sorgenti in quanto si tratta di una   ver-
	sione sperimentale fatta alla buona e quindi modificabile     e
	in particolar modo migliorabile.
	Se avete idee da proporre potete contattarmi su :
	Fido 33/3 Tel. 0131-355506 
*/

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <types.h>
#include <process.h>
#include <dos.h>
#include <direct.h>
#include <stat.h>

#define CUR_MV(row, col) fprintf(stderr,"\33[%d;%dH", row, col)
#define CLR_SCRN fputs("\33[2J", stderr)
#define CLR_LINE fputs("\33[K", stderr)
#define BELL fputc('\7', stderr)
#define REVERSE puts("\33[7m")
#define NORMAL puts("\33[0m")
#define LAMP puts("\33[5m")
#define COL1 puts("\33[36m")
#define COL2 puts("\33[33m")
#define COL3 puts("\33[32m")
#define PRINT(n) putc(n,stdprn)

static char *co[] = {
                    "F_Bernardotti",
					"1986 Alessandria"
			        };
FILE *infile;
char pathbuf[40];
char fcb[44];
char bfr[135];
char dir[1000][14];
char tipo[12];
char ext[4];
char st_fil[13];
int tot, set2, set, status, indice, c;
int dir_2, tmp_s;

union REGS inregs, outregs;
struct stat file;

main()
{
		in_video();
		introd();
		sort_dir();
		first_show();
		while((c = inchar()) != EOF)
		{
		switch(c)
		{
		case '\033':
		     end_visual();
			 break;
        case '\043':
		     get_free();
			 pause();
			 CLR_SCRN;
		     first_show();
			 break;
        case '\040':
				if(set2 == tot)
				first_show();
				else
				show_dir();
				break;
		case '%':
		        set_drive();
				CLR_SCRN;
				sort_dir();
				first_show();
				break;
		case '!':
		        pr();
				break;
		case '?':
		        help();
				first_show();
				break;
		case '@':
                show_perif();
			    first_show();
				break;
        default:
		        analiz();
				if(status == 1)
				{
				status=0;
				sort_dir();
		        first_show();
				}
				else
				{
				set2=tmp_s;
				show_dir();
				}
				break;
}
put_masch();
}
exit(0);
}
show_dir()
{
int inc, i, p, p_c, s_c, lim;
inc = 97;
p = 0;
CLR_SCRN;
                if(tot-set2>=20)
				{
				set=20;
				p_c=10;
				s_c=10;
				}
				else
				set = tot-set2;
if(set>=10 && set<20)
{
p_c=10;
s_c=set-p_c;
}
if(set<10)
{
p_c=set;
s_c=0;
}
COL1;
tmp_s=set2;
lim=set2+p_c;
for(i = set2;i!=lim; i++)
{  
   CUR_MV(9+p,16);
   printf("%c - ", inc);
   printf("%s\n", dir[i]);
   inc++;
   p++;
}
p=0;
lim=i+s_c;
for(;i!=lim; i++)
{
   CUR_MV(9+p,48);
   printf("%c - ", inc);
   printf("%s\n", dir[i]);
   inc++;
   p++;
}
NORMAL;
set2 = i;
}
get_free()
{
        long val_bx, val_dx, val_cx, val_ax;
		inregs.h.ah = 0x36;
		inregs.h.dl = 0x00;
		intdos(&inregs, &outregs);
        val_bx = outregs.x.bx; 
		val_dx = outregs.x.dx;
		val_cx = outregs.x.cx; 
		val_ax = outregs.x.ax;

		CLR_SCRN;
		CUR_MV(9,1);

              if (val_ax == 0xFFFF)
			  {
			     printf("\nCi sono cluster non validi");
                 exit(-1);
			  }
	    COL1;
  printf("\n\t\t      Spazio  disco in bytes : %10ld ", val_cx*val_ax*val_dx);
  printf("\n\n\t\t      Spazio libero in bytes : %10ld ", val_cx*val_ax*val_bx);
  printf("\n\n\t\t      Percentuale libera     : %10ld \n\n", (val_bx*100)/val_dx);
        NORMAL;
		put_masch();
}
fi(b,drive,name,ext,tipo)
char *b;
char drive;
char *name;
char *ext;
char tipo;

{
        int y;
	    register unsigned int regax;
	    register int i;
	    static int first_entry = 0;
		y=0;
	    fcb[0] = 255;
	    strncpy(&fcb[1], "\0\0\0\0\0", 5);
	    fcb[6] = tipo;
	    fcb[7] = drive;
	    strncpy(&fcb[8], name, 8);
	    strncpy(&fcb[16], ext, 3);
	    if (first_entry == 0)
	    {
		    first_entry = 1;
		    bdos(0x1A, bfr);
		    regax = bdos(0x11, fcb);
	    }
	    else
		regax = bdos(0x12, fcb);
	    if ((regax & 0x00FF) == 0xff)
	    {
		    first_entry = 0;
		    return(NULL);
	    }
	    if(bfr[19] == 16)   
		{
		     b[13] = 1;
		     y=1;
		}
	    else 
		b[13] = 0;
	    for(i = 0; i < 12;++i) b[i] = ' ';
	    for(i = 0; i < 8;++i) b[i] = bfr[i+8];
		if(y==0) b[8] = '.';
		else
		b[8] = '>';
	    if(y==0)for(i = 0;i < 3;++i) b[i+9] = bfr[i+16];
		else
		{
		strcpy(&b[9],"DIR",3);
		y=0;
		}
	    return(b); 
}
put_masch()
{
long ltime;
getcwd(pathbuf,40);
time(&ltime);
CUR_MV(1,1);
printf("_______________________________________________________________________________\n");
COL3;
printf("\n Files in Directory : %d \t\t  Data : %s ", tot, ctime(&ltime));
NORMAL;
printf("_______________________________________________________________________________");
COL3;
CUR_MV(21,30);
printf(" Path  : %s", pathbuf);
NORMAL;
printf("_______________________________________________________________________________\n");
printf("\n VSH : ? per help > ");
}
end_visual()
{
CLR_SCRN;
puts("Ritorno al DOS.\n\n");
exit(0);
}
pause()
{
int i;
i = inchar();
}
introd()
{
CLR_SCRN;
COL1;
CUR_MV(6,31);
puts("__________________");
CUR_MV(8,31);
puts("   VISUAL SHELL   ");
CUR_MV(9,31);
puts("__________________");
NORMAL;
CUR_MV(12,39);
puts("by");
CUR_MV(14,33);
puts("F. Bernardotti");
CUR_MV(19,1);
puts("      Autorizzato  per  il  publico  dominio  per  usi  non  commerciali");
COL2;
CUR_MV(23,1);
puts("      (C)opyright  1986 - FIDO BBS (33/3) Tel. 0131/355506 - Alessandria");
NORMAL;
pause();
}

inchar()
{
inregs.h.ah = 0x0C;
inregs.h.al = 0x01;
intdos( &inregs, &outregs);
return(outregs.h.al);
}
help()
{
CLR_SCRN;
COL1;
puts("VISUAL SHELL - by F. Bernardotti Sysop on FIDO 33/3 Montecastello ITALY");
NORMAL;
COL3;
puts("La Visual Shell carica in memoria la directory in cui e' stata lanciata");
puts("e ne visualizza il contenuto facendo precedere il nome del file o della");
puts("directory da una lettera.");
puts("Premendo la lettera minuscola si ottengono le informazioni  riguardanti");
puts("il file abbinato oppure premendo la lettera maiuscola si fa' si che  il");
puts("file venga eseguito od editato a seconda della natura di questo.");
puts("Se la lettera maiuscola e' relativo a una directory ( >DIR )  la    VSH");
puts("entrera' in questa e vi mostrera' i file presenti.");
puts("La Visual Shell provvede anche a restituire informazioni  sui   devices");
puts("installati sul PC.");
NORMAL;
puts("\n\t%     - cambia il drive (A, B, C o D)");
puts("\t!     - stampa schermata");
puts("\t#     - riporta lo spazio totale e quello libero del disco");
puts("\t@     - riporta informazioni sulle periferiche installate ");
puts("\t?     - visualizza questa schermata.");
puts("\tESC   - per uscire al DOS");
puts("\tSpace - scorri la directory");
pause();
}
in_video()
{
inregs.h.ah = 0x00;
inregs.h.al = 0x03;
int86(0x10, &inregs,&outregs);
}

show_perif()
{

long var1, var2, var4;
unsigned lpt, game, rs_232;

static char *screen[] = {
"40x25 BW",
"40x25 Colore",
"80x25 BW",
"80x25 Colore",
"Grafico 320x200 Colore",
"Grafico 320x200 BW",
"Grafico 640x200 BW"
};
CLR_SCRN;
COL1;
CUR_MV(10,1);
inregs.h.ah = 0x30;
intdos( &inregs, &outregs );
var1 = outregs.h.al;
var2 = outregs.h.ah;
printf("\n\t\t      Versione DOS         : %ld.%ld", var1, var2);
inregs.h.ah = 15;
int86 (0x10,&inregs, &outregs);
var4 = outregs.h.al;
printf("\n\t\t      Modo Video           : %s", screen[var4]);
int86 (0x11, &inregs, &outregs);
lpt = outregs.x.ax >> 14;
game = outregs.x.ax >> 12 & 1;
if (game == '\001') printf("\n\t\t      Presente porta games");
rs_232 = outregs.x.ax >> 9 & 3;
printf("\n\t\t      Stampanti collegate  : %d", lpt);
printf("\n\t\t      Porte Seriali        : %d", rs_232);
int86 (0x12, &inregs, &outregs);
printf("\n\t\t      Dimensione RAM Kbyte : %d", outregs.x.ax);
put_masch();
pause();
}
analiz()
{
int k, tasto;
tasto = c;
dir_2=0;
if(tasto < 'A' || tasto > 'T')
if(tasto < 'a' || tasto > 't')
{
BELL;
return;
}
if(tasto >= 'a' && tasto <= 't')
{
   indice = set2-set+(tasto-'a');
   copy_field();
   if(dir_2==0)
   {
   k = stat(st_fil,&file);
        if(k == -1)
		{
		BELL;
		CUR_MV(24,1);
		printf("             Non mi e' possibile avere informazioni del file  ");
		pause();
		return;
		}
		if(k == 0)
		{
		    if((strcmp(ext,".EXE")==0) || (strcmp(ext,".COM")==0) || (strcmp(ext,".BAT")==0))
			strcpy(tipo,"Eseguibile");
			else
			if((strcmp(ext,">DIR")==0))
			strcpy(tipo,"Directory");
			else
			strcpy(tipo,"Non eseguibile");
		}

        CUR_MV(24,1);
		printf("        File : %s   Tipo : %s   Byte : %ld\n ", st_fil, tipo, file.st_size);
		pause();
		return;
}
if(dir_2==1)
{
CUR_MV(24,1);
printf("                              Questa Directory");
pause();
return;
}
if(dir_2=2)
{
CUR_MV(24,1);
printf("                            Directory Precedente");
pause();
return;
}

}
if(tasto >= 'A' && tasto <= 'T')
{
   indice = set2-set+(tasto-'A');
   copy_field();
   if(dir_2==0)
   {
   k = stat(st_fil, &file);
   if(k == -1)
   {
   BELL;
   CUR_MV(24,1);
   printf("                  Non mi e' possibile avere informazioni del file\n   ");
   pause();
   return;
   }
   if(k == 0)
   {
   if(strcmp(ext,">DIR")==0)
   {
        chdir(st_fil);
        status=1;
        return;
   }
   if(strcmp(ext,".EXE")==0||strcmp(ext,".COM")==0||strcmp(ext,".BAT")==0)
   {
        system(st_fil);
		printf("\n\n\n");
		REVERSE;
        printf("\nProcesso terminato");
		NORMAL;
        pause();
        status=1;
        return;
   }
   else
   edit();
   }
   }
   if(dir_2==2)
   {
   chdir("..");
   status=1;
   return;
   }
}
}
first_show()
{
        set2=0;
		if(tot >= 20) set=20;
		else
		set = tot;
		show_dir();
		put_masch();
}
sort_dir()
{
        int flag, r, s;
		char tempor[14];
	    tot=0;
	    s = flag = 1;

	    CLR_SCRN;
		while(fi(dir[tot++],0,"????????","???",16) != NULL);
	    --tot;
	    while(flag == 1) 
		{               
		    flag = 0;
		    for (r = 0;r != tot-s;r++)
		    if (strcmp(dir[r],dir[r+1]) > 0)
			{
			    strcpy(tempor, dir[r], 14);
			    strcpy(dir[r], dir[r+1], 14);
			    strcpy(dir[r+1], tempor, 14);
			    flag = 1;
		    }
		    ++s;
	    }
		set2=0;
		set=0;
}
copy_field()
{ 
   int i, se;

   for(i=0;i <12;i++) st_fil[i] = ' ';
   for(i=0;i != 5;i++) ext[i] = dir[indice][i+8];
   se = strcmp(ext,">DIR");
   if(se==0)
   {
   for(i=0;i<8;i++) st_fil[i] = dir[indice][i];
   st_fil[8] = '.';
   for(i=0;i<3;i++) st_fil[i+9] = ' ';
   }
   else
   for(i=0;i<12;i++) st_fil[i]=dir[indice][i];
   se = strcmp(st_fil,".       .   ");
   if (se==0) 
   dir_2=1;
   se = strcmp(st_fil,"..      .   ");
   if (se==0)
   dir_2=2;
}
edit()
{
int row, risp, c;
row=2;
CLR_SCRN;
REVERSE;
printf("Edito file : %s\n\n",st_fil);
NORMAL;
infile=fopen(st_fil,"r");
while((c=getc(infile))!=EOF)
{
if(c=='\n') ++row;
if(row == 20)
{
puts("\n\nMore ?");
risp=inchar();
if(risp=='n'||risp=='N')
return;
row=0;
}
putchar(c);
}
REVERSE;
printf("Fine Editazione");
pause();
NORMAL;
}
pr()
{
int86(0x05,&inregs,&outregs);
}
set_drive()
{
int scelta, tmp;
CUR_MV(24,1);
printf("      Drive  Selezionato  (A, B, C ecc.) : ");
scelta=inchar();
switch(scelta)
{
case 'A':
case 'a':
        tmp=0;
		break;
case 'B':
case 'b':
        tmp=1;
		break;
case 'C':
case 'c':
        tmp=2;
		break;
case 'D':
case 'd':
        tmp=3;
		break;
default:
        CUR_MV(24,1);
		printf("             Selezione   non   valida.   Deve essere  A B C o D.");
		pause();
		return;
		break;
}
inregs.h.ah = 0x0E;
inregs.h.dl=tmp;
intdos(&inregs,&outregs);
}

